package tilings;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Set;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.DefaultTreeSelectionModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;

import tilingTypes.*;
import tilingTypes.N3.*;
import tilingTypes.N4.*;
import tilingTypes.N5.Other.*;
import tilingTypes.N5.Type1.*;
import tilingTypes.N5.Type2.*;
import tilingTypes.N6.*;
import tilingTypes.NC5.Iso.*;
import tilingTypes.NC5.Other.*;
import tilingTypes.NC5.Type1.*;
import tilingTypes.NC5.Type2.*;
import tilingTypes.NC6.*;
import tilingTypes.NC6.Iso.*;
import tilingTypes.P3.*;
import tilingTypes.P4.*;
import tilingTypes.P5.*;
import tilingTypes.P6.*;

public class PanelChooseTiling
   extends JPanel
   implements TreeSelectionListener, ActionListener
{
   final private Object menuData = new Object[]{
         "Tilings",
         new Object[]{
               "Triangle Tilings",
               new Object[]{
                     "Isohedral *",
                     new TilingTypeP3_01(),
                     new TilingTypeP3_02(),
                     new TilingTypeP3_03(),
                     new TilingTypeP3_04(),
                     new TilingTypeP3_06(),
                     new TilingTypeP3_08(),
                     new TilingTypeP3_09(),
                     new TilingTypeP3_12(),
               },new Object[]{
                     "2-isohedral, 1:1 *",
                     new TilingTypeN3_01(),
                     new TilingTypeN3_02a(),
                     new TilingTypeN3_02b(),
                     new TilingTypeN3_03(),
                     new TilingTypeN3_04a(),
                     new TilingTypeN3_04b(),
                     new TilingTypeN3_04c(),
                     new TilingTypeN3_05(),
                     new TilingTypeN3_06(),
                     new TilingTypeN3_07(),
                     new TilingTypeN3_08a(),
                     new TilingTypeN3_08b(),
                     new TilingTypeN3_09(),
                     new TilingTypeN3_10(),
                     new TilingTypeN3_11a(),
                     new TilingTypeN3_11b(),
                     new TilingTypeN3_12(),
                     new TilingTypeN3_13(),
                     new TilingTypeN3_14(),
                     new TilingTypeN3_15(),
                     new TilingTypeN3_16a(),
                     new TilingTypeN3_16b(),
                     new TilingTypeN3_17(),
               },new Object[]{
                     "3-isohedral",
                     new TilingTypeN3_18(),
                     new TilingTypeN3_19(),
                     new TilingTypeN3_20(),
                     new TilingTypeN3_21(),
                     new TilingTypeN3_22(),
                     new TilingTypeN3_23a(),
                     new TilingTypeN3_23b(),
                     new TilingTypeN3_24a(),
                     new TilingTypeN3_24b(),
                     new TilingTypeN3_25a(),
                     new TilingTypeN3_25b(),
                     new TilingTypeN3_25c(),
                     new TilingTypeN3_25d(),
                     new TilingTypeN3_26b(),
                     new TilingTypeN3_26c(),
                     new TilingTypeN3_26d(),
                     new TilingTypeN3_26e(),
                     new TilingTypeN3_27(),
                     new TilingTypeN3_28a(),
                     new TilingTypeN3_28b(),
                     new TilingTypeN3_29(),
                     new TilingTypeN3_30a(),
                     new TilingTypeN3_30b(),
                     new TilingTypeN3_32(),
                     new TilingTypeN3_33a(),
                     new TilingTypeN3_33b(),
                     new TilingTypeN3_33c(),
                     new TilingTypeN3_33d(),
                     new TilingTypeN3_33e(),
                     new TilingTypeN3_33f(),
                     new TilingTypeN3_34a(),
                     new TilingTypeN3_34b(),
                     new TilingTypeN3_34c(),
                     new TilingTypeN3_34d(),
                     new TilingTypeN3_34e(),
                     new TilingTypeN3_35(),
                     new TilingTypeN3_51a(),
                     new TilingTypeN3_51b(),
                     new TilingTypeN3_52a(),
                     new TilingTypeN3_52b(),
                     new TilingTypeN3_53a(),
                     new TilingTypeN3_53b(),
                     new TilingTypeN3_53c(),
                     new TilingTypeN3_53d(),
                     new TilingTypeN3_53e(),
                     new TilingTypeN3_53f(),
                     new TilingTypeN3_54a(),
                     new TilingTypeN3_54b(),
                     new TilingTypeN3_54d(),
                     new TilingTypeN3_54e(),
                     new TilingTypeN3_54f(),
                     new TilingTypeN3_54g(),
                     new TilingTypeN3_55a(),
                     new TilingTypeN3_55c(),
                     new TilingTypeN3_56a(),
                     new TilingTypeN3_56b(),
                     new TilingTypeN3_56c(),
                     new TilingTypeN3_56d(),
                     new TilingTypeN3_56e(),
                     new TilingTypeN3_56f(),
                     new TilingTypeN3_57a(),
                     new TilingTypeN3_57b(),
                     new TilingTypeN3_57c(),
                     new TilingTypeN3_57d(),
                     new TilingTypeN3_57e(),
                     new TilingTypeN3_57f(),
                     new TilingTypeN3_58a(),
                     new TilingTypeN3_58b(),
                     new TilingTypeN3_59a(),
                     new TilingTypeN3_59b(),
                     new TilingTypeN3_60a(),
                     new TilingTypeN3_60b(),
                     new TilingTypeN3_60c(),
                     new TilingTypeN3_61a(),
                     new TilingTypeN3_61b(),
                     new TilingTypeN3_62a(),
                     new TilingTypeN3_62b(),
                     new TilingTypeN3_63a(),
                     new TilingTypeN3_63b(),
               },new Object[]{
                     "4-isohedral",
                     new TilingTypeN3_36(),
                     new TilingTypeN3_37a(),
                     new TilingTypeN3_37b(),
                     new TilingTypeN3_37c(),
                     new TilingTypeN3_37d(),
                     new TilingTypeN3_38(),
                     new TilingTypeN3_39(),
                     new TilingTypeN3_40a(),
                     new TilingTypeN3_40b(),
                     new TilingTypeN3_41(),
                     new TilingTypeN3_42(),
                     new TilingTypeN3_43(),
                     new TilingTypeN3_44(),
                     new TilingTypeN3_45(),
                     new TilingTypeN3_46(),
                     new TilingTypeN3_47(),
                     new TilingTypeN3_48(),
                     new TilingTypeN3_49(),
                     new TilingTypeN3_50(),
                     new TilingTypeN3_64(),
              },
         },new Object[]{
               "Quadrangle Tilings",
               new Object[]{
                     "Isohedral *",
                     new TilingTypeP4_01(),
                     new TilingTypeP4_02(),
                     new TilingTypeP4_03(),
                     new TilingTypeP4_04(),
                     new TilingTypeP4_05(),
                     new TilingTypeP4_07(),
                     new TilingTypeP4_08(),
                     new TilingTypeP4_09(),
                     new TilingTypeP4_10(),
                     new TilingTypeP4_12(),
                     new TilingTypeP4_14(),
                     new TilingTypeP4_15(),
                     new TilingTypeP4_17(),
                     new TilingTypeP4_19(),
                     new TilingTypeP4_23(),
                     new TilingTypeP4_24(),
                     new TilingTypeP4_25(),
                     new TilingTypeP4_26(),
                     new TilingTypeP4_27(),
                     new TilingTypeP4_28(),
                     new TilingTypeP4_30(),
                     new TilingTypeP4_31(),
                     new TilingTypeP4_35(),
                     new TilingTypeP4_37(),
                     new TilingTypeP4_38(),
                     new TilingTypeP4_40(),
                     new TilingTypeP4_42(),
                     new TilingTypeP4_43(),
                     new TilingTypeP4_44(),
                     new TilingTypeP4_46(),
                     new TilingTypeP4_47(),
                     new TilingTypeP4_48(),
                     new TilingTypeP4_49(),
               },new Object[]{
                     "2-isohedral, 1:1 *",
                     new Object[]{
                           "Parallellograms *",
                           new TilingTypeN4_08a(),
                           new TilingTypeN4_08b(),
                           new TilingTypeN4_08c(),
                           new TilingTypeN4_08d(),
                           new TilingTypeN4_12(),
                           new TilingTypeN4_13a(),
                           new TilingTypeN4_13b(),
                           new TilingTypeN4_13c(),
                           new TilingTypeN4_13d(),
                           new TilingTypeN4_13e(),
                           new TilingTypeN4_13f(),
                           new TilingTypeN4_19(),
                           new TilingTypeN4_20(),
                           new TilingTypeN4_21a(),
                           new TilingTypeN4_21b(),
                           new TilingTypeN4_21c(),
                           new TilingTypeN4_22(),
                           new TilingTypeN4_23a(),
                           new TilingTypeN4_23b(),
                           new TilingTypeN4_29f(),
                           new TilingTypeN4_29k(),
                           new TilingTypeN4_40a(),
                           new TilingTypeN4_40b(),
                           new TilingTypeN4_40c(),
                           new TilingTypeN4_40d(),
                           new TilingTypeN4_40e(),
                           new TilingTypeN4_40f(),
                           new TilingTypeN4_40g(),
                           new TilingTypeN4_40h(),
                           new TilingTypeN4_40i(),
                           new TilingTypeN4_40j(),
                           new TilingTypeN4_41a(),
                           new TilingTypeN4_41b(),
                           new TilingTypeN4_41c(),
                           new TilingTypeN4_41d(),
                           new TilingTypeN4_41e(),
                           new TilingTypeN4_42a(),
                           new TilingTypeN4_42b(),
                           new TilingTypeN4_42c(),
                           new TilingTypeN4_42d(),
                           new TilingTypeN4_42e(),
                           new TilingTypeN4_47f(),
                           new TilingTypeN4_47g(),
                           new TilingTypeN4_48a(),
                           new TilingTypeN4_48b(),
                           new TilingTypeN4_48c(),
                           new TilingTypeN4_49a(),
                           new TilingTypeN4_49b(),
                           new TilingTypeN4_49c(),
                           new TilingTypeN4_49d(),
                           new TilingTypeN4_50(),
                           new TilingTypeN4_51a(),
                           new TilingTypeN4_51b(),
                           new TilingTypeN4_52(),
                           new TilingTypeN4_53a(),
                           new TilingTypeN4_53b(),
                           new TilingTypeN4_53c(),
                           new TilingTypeN4_53d(),
                           new TilingTypeN4_53e(),
                           new TilingTypeN4_53f(),
                           new TilingTypeN4_54a(),
                           new TilingTypeN4_54b(),
                           new TilingTypeN4_54c(),
                           new TilingTypeN4_54d(),
                           new TilingTypeN4_54e(),
                           new TilingTypeN4_54f(),
                           new TilingTypeN4_55(),
                           new TilingTypeN4_56a(),
                           new TilingTypeN4_56b(),
                           new TilingTypeN4_56c(),
                           new TilingTypeN4_56d(),
                           new TilingTypeN4_57a(),
                           new TilingTypeN4_57b(),
                           new TilingTypeN4_57c(),
                           new TilingTypeN4_57d(),
                           new TilingTypeN4_57e(),
                           new TilingTypeN4_57f(),
                           new TilingTypeN4_58(),
                           new TilingTypeN4_59b(),
                           new TilingTypeN4_62a(),
                           new TilingTypeN4_62b(),
                           new TilingTypeN4_63(),
                           new TilingTypeN4_64a(),
                           new TilingTypeN4_65(),
                           new TilingTypeN4_66(),
                           new TilingTypeN4_67(),
                     },new Object[]{
                           "Other *",
                           new TilingTypeN4_01a(),
                           new TilingTypeN4_01b(),
                           new TilingTypeN4_03a(),
                           new TilingTypeN4_03b(),
                           new TilingTypeN4_03c(),
                           new TilingTypeN4_05a(),
                           new TilingTypeN4_05b(),
                           new TilingTypeN4_06a(),
                           new TilingTypeN4_06b(),
                           new TilingTypeN4_07(),
                           new TilingTypeN4_09(),
                           new TilingTypeN4_10(),
                           new TilingTypeN4_11a(),
                           new TilingTypeN4_11b(),
                           new TilingTypeN4_11c(),
                           new TilingTypeN4_14(),
                           new TilingTypeN4_15(),
                           new TilingTypeN4_16a(),
                           new TilingTypeN4_16b(),
                           new TilingTypeN4_17(),
                           new TilingTypeN4_18(),
                           new TilingTypeN4_25(),
                           new TilingTypeN4_26a(),
                           new TilingTypeN4_26b(),
                           new TilingTypeN4_27(),
                           new TilingTypeN4_36(),
                           new TilingTypeN4_37a(),
                           new TilingTypeN4_37b(),
                           new TilingTypeN4_37c(),
                           new TilingTypeN4_38(),
                           new TilingTypeN4_43(),
                           new TilingTypeN4_44(),
                           new TilingTypeN4_45(),
                           new TilingTypeN4_46(),
                           new TilingTypeN4_47a(),
                           new TilingTypeN4_47b(),
                           new TilingTypeN4_47c(),
                           new TilingTypeN4_47d(),
                           new TilingTypeN4_47e(),
                           new TilingTypeN4_59a(),
                           new TilingTypeN4_60a(),
                           new TilingTypeN4_60b(),
                           new TilingTypeN4_60c(),
                           new TilingTypeN4_61(),
                           new TilingTypeN4_64b(),
                           new TilingTypeN4_68(),
                           new TilingTypeN4_69(),
                           new TilingTypeN4_70(),
                           new TilingTypeN4_71(),
                           new TilingTypeN4_72(),
                           new TilingTypeN4_73a(),
                           new TilingTypeN4_73b(),
                           new TilingTypeN4_74(),
                    }
               },new Object[]{
                     "2-isohedral,  2:1",
                     new TilingTypeN4_23c(),
                     new TilingTypeN4_23d(),
                     new TilingTypeN4_29e(),
                     new TilingTypeN4_31(),
                     new TilingTypeN4_82(),
               },new Object[]{
                     "3-isohedral",
                     new TilingTypeN4_02a(),
                     new TilingTypeN4_02b(),
                     new TilingTypeN4_02c(),
                     new TilingTypeN4_05c(),
                     new TilingTypeN4_05d(),
                     new TilingTypeN4_05e(),
                     new TilingTypeN4_05f(),
                     new TilingTypeN4_06c(),
                     new TilingTypeN4_06d(),
                     new TilingTypeN4_06e(),
                     new TilingTypeN4_06f(),
                     new TilingTypeN4_06g(),
                     new TilingTypeN4_06h(),
                     new TilingTypeN4_06i(),
                     new TilingTypeN4_06j(),
                     new TilingTypeN4_11d(),
                     new TilingTypeN4_11e(),
                     new TilingTypeN4_11f(),
                     new TilingTypeN4_11g(),
                     new TilingTypeN4_11h(),
                     new TilingTypeN4_11i(),
                     new TilingTypeN4_11j(),
                     new TilingTypeN4_11k(),
                     new TilingTypeN4_13g(),
                     new TilingTypeN4_13h(),
                     new TilingTypeN4_26c(),
                     new TilingTypeN4_26d(),
                     new TilingTypeN4_26e(),
                     new TilingTypeN4_26f(),
                     new TilingTypeN4_26g(),
                     new TilingTypeN4_29a(),
                     new TilingTypeN4_29b(),
                     new TilingTypeN4_29c(),
                     new TilingTypeN4_29d(),
                     new TilingTypeN4_29g(),
                     new TilingTypeN4_29h(),
                     new TilingTypeN4_29i(),
                     new TilingTypeN4_29j(),
                     new TilingTypeN4_29l(),
                     new TilingTypeN4_29m(),
                     new TilingTypeN4_30a(),
                     new TilingTypeN4_30b(),
                     new TilingTypeN4_32a(),
                     new TilingTypeN4_32b(),
                     new TilingTypeN4_32c(),
                     new TilingTypeN4_32d(),
                     new TilingTypeN4_33a(),
                     new TilingTypeN4_33b(),
                     new TilingTypeN4_33c(),
                     new TilingTypeN4_34a(),
                     new TilingTypeN4_34b(),
                     new TilingTypeN4_34c(),
                     new TilingTypeN4_34d(),
                     new TilingTypeN4_34e(),
                     new TilingTypeN4_35a(),
                     new TilingTypeN4_35b(),
                     new TilingTypeN4_35c(),
                     new TilingTypeN4_35d(),
                     new TilingTypeN4_35e(),
                     new TilingTypeN4_73c(),
                     new TilingTypeN4_75a(),
                     new TilingTypeN4_75b(),
                     new TilingTypeN4_75c(),
                     new TilingTypeN4_75d(),
                     new TilingTypeN4_76a(),
                     new TilingTypeN4_76b(),
                     new TilingTypeN4_77a(),
                     new TilingTypeN4_77b(),
                     new TilingTypeN4_77c(),
                     new TilingTypeN4_78a(),
                     new TilingTypeN4_78b(),
                     new TilingTypeN4_79(),
                     new TilingTypeN4_80(),
                     new TilingTypeN4_81(),
                     new TilingTypeN4_83(),
                     new TilingTypeN4_84(),
                     new TilingTypeN4_85a(),
                     new TilingTypeN4_85b(),
                     new TilingTypeN4_85c(),
                     new TilingTypeN4_85d(),
                     new TilingTypeN4_85e(),
                     new TilingTypeN4_86a(),
                     new TilingTypeN4_86b(),
               },
         },new Object[]{
               "Pentagon Tilings",
               new Object[]{
                     "Convex",
                     new Object[]{
                           "By type",
                           new Object[]{
                                 "Type 1",
                                 new TilingTypeP5_01(),
                                 new TilingTypeP5_02(),
                                 new TilingTypeP5_03(),
                                 new TilingTypeP5_03b(),
                                 new TilingTypeP5_04(),
                                 new TilingTypeP5_05(),
                                 new TilingTypeP5_06(),
                                 new TilingTypeP5_07(),
                                 new TilingTypeP5_08(),
                                 new TilingTypeP5_09(),
                                 new TilingTypeP5_12(),
                                 new TilingTypeP5_17(),
                                 new TilingTypeP5_19(),
                                 new TilingTypeN5_01a1(),
                                 new TilingTypeN5_01a2(),
                                 new TilingTypeN5_01a3(),
                                 new TilingTypeN5_01a4(),
                                 new TilingTypeN5_01b1(),
                                 new TilingTypeN5_01b2(),
                                 new TilingTypeN5_01b3(),
                                 new TilingTypeN5_01b4(),
                                 new TilingTypeN5_01b5(),
                                 new TilingTypeN5_01b6(),
                                 new TilingTypeN5_01c(),
                                 new TilingTypeN5_01d(),
                                 new TilingTypeN5_01e1(),
                                 new TilingTypeN5_01e2(),
                                 new TilingTypeN5_01f(),
                                 new TilingTypeN5_01g(),
                                 new TilingTypeN5_01h(),
                                 new TilingTypeN5_01i(),
                                 new TilingTypeN5_01j1(),
                                 new TilingTypeN5_01j2(),
                                 new TilingTypeN5_01k1(),
                                 new TilingTypeN5_01l1(),
                                 new TilingTypeN5_01m(),
                                 new TilingTypeN5_01n(),
                                 new TilingTypeN5_01o1(),
                                 new TilingTypeN5_01o2(),
                                 new TilingTypeN5_01o3(),
                                 new TilingTypeN5_01o4(),
                                 new TilingTypeN5_01o5(),
                                 new TilingTypeN5_01o6(),
                                 new TilingTypeN5_01o7(),
                                 new TilingTypeN5_01o8(),
                                 new TilingTypeN5_01o9(),
                                 new TilingTypeN5_01p1(),
                                 new TilingTypeN5_01p2(),
                                 new TilingTypeN5_01q1(),
                                 new TilingTypeN5_01q2(),
                                 new TilingTypeN5_01t(),
                                 new TilingTypeN5_01u(),
                                 new TilingTypeN5_01v(),
                                 new TilingTypeN5_01w(),
                                 new TilingTypeN5_01x(),
                                 new TilingTypeN5_01y(),
                                 new TilingTypeN5_01z1(),
                                 new TilingTypeN5_01z2(),
                                 new TilingTypeN5_01aa(),
                                 new TilingTypeN5_01ab1(),
                                 new TilingTypeN5_01ab2(),
                                 new TilingTypeN5_01ac1(),
                                 new TilingTypeN5_01ac2(),
                                 new TilingTypeN5_01ac3(),
                                 new TilingTypeN5_01ac4(),
                                 new TilingTypeN5_01ac5(),
                                 new TilingTypeN5_01ac6(),
                                 new TilingTypeN5_01ac7(),
                                 new TilingTypeN5_01ac8(),
                                 new TilingTypeN5_01ad(),
                                 new TilingTypeN5_01ae(),
                                 new TilingTypeN5_01af(),
                                 new TilingTypeN5_01ag1(),
                                 new TilingTypeN5_01ag2(),
                                 new TilingTypeN5_01ah(),
                                 new TilingTypeN5_01ai(),
                                 new TilingTypeN5_01aj(),
                                 new TilingTypeN5_01ak(),
                                 new TilingTypeN5_01al(),
                                 new TilingTypeN5_01am1(),
                                 new TilingTypeN5_01am2(),
                                 new TilingTypeN5_01an(),
                                 new TilingTypeN5_01ao(),
                                 new TilingTypeN5_01ap(),
                                 new TilingTypeN5_01aq(),
                                 new TilingTypeN5_01ar(),
                                 new TilingTypeN5_01as(),
                                 new TilingTypeN5_01at(),
                                 new TilingTypeN5_01au(),
                                 new TilingTypeN5_01av(),
                                 new TilingTypeN5_01aw(),
                                 new TilingTypeN5_01ax(),
                                 new TilingTypeN5_01ay(),
                                 new TilingTypeN5_01az(),
                                 new TilingTypeN5_01ba(),
                                 new TilingTypeN5_01bb(),
                                 new TilingTypeN5_01bc(),
                                 new TilingTypeN5_01bd(),
                                 new TilingTypeN5_01be(),
                                 new TilingTypeN5_01k2(),
                                 new TilingTypeN5_01k3(),
                                 new TilingTypeN5_01l2(),
                                 new TilingTypeN5_01l3(),
                                 new TilingTypeN5_01r1(),
                                 new TilingTypeN5_01r2(),
                                 new TilingTypeN5_01r3(),
                                 new TilingTypeN5_01r4(),
                                 new TilingTypeN5_01r5(),
                                 new TilingTypeN5_01r6(),
                                 new TilingTypeN5_01s(),
                                 new TilingTypeN5_01bf1(),
                                 new TilingTypeN5_01bg1(),
                                 new TilingTypeN5_01bg2(),
                                 new TilingTypeN5_01bh(),
                                 new TilingTypeN5_01bi(),
                                 new TilingTypeN5_01bj(),
                                 new TilingTypeN5_01bk(),
                                 new TilingTypeN5_01bl(),
                                 new TilingTypeN5_01bm(),
                                 new TilingTypeN5_01bn(),
                                 new TilingTypeN5_01bo(),
                                 new TilingTypeN5_01bp(),
                                 new TilingTypeN5_01bq1(),
                                 new TilingTypeN5_01bq2(),
                                 new TilingTypeN5_01bs1(),
                                 new TilingTypeN5_01bs2(),
                                 new TilingTypeN5_01br1(),
                                 new TilingTypeN5_01br2(),
                                 new TilingTypeN5_01br3(),
                                 new TilingTypeN5_01br4(),
                                 new TilingTypeN5_01br5(),
                                 new TilingTypeN5_01br6(),
                                 new TilingTypeN5_01br7(),
                                 new TilingTypeN5_01br8(),
                                 new TilingTypeN5_01br9(),
                                 new TilingTypeN5_01br10(),
                                 new TilingTypeN5_01bt(),
                                 new TilingTypeN5_01bu(),
                                 new TilingTypeN5_01bv(),
                                 new TilingTypeN5_01bw(),
                                 new TilingTypeN5_01bf2(),
                                 new TilingTypeN5_01bx1(),
                                 new TilingTypeN5_01bx3(),
                                 new TilingTypeN5_01bx4(),
                           },
                           new Object[]{
                                 "Type 2",
                                 new TilingTypeP5_03(),
                                 new TilingTypeP5_03b(),
                                 new TilingTypeP5_10(),
                                 new TilingTypeP5_22(),
                                 new TilingTypeN5_01f(),
                                 new TilingTypeN5_01i(),
                                 new TilingTypeN5_01j1(),
                                 new TilingTypeN5_01j2(),
                                 new TilingTypeN5_01k1(),
                                 new TilingTypeN5_01l1(),
                                 new TilingTypeN5_01n(),
                                 new TilingTypeN5_01ac1(),
                                 new TilingTypeN5_01ac2(),
                                 new TilingTypeN5_01ac3(),
                                 new TilingTypeN5_01ac4(),
                                 new TilingTypeN5_01ac5(),
                                 new TilingTypeN5_01ac6(),
                                 new TilingTypeN5_01ac7(),
                                 new TilingTypeN5_01ac8(),
                                 new TilingTypeN5_01ad(),
                                 new TilingTypeN5_01ae(),
                                 new TilingTypeN5_01af(),
                                 new TilingTypeN5_01aj(),
                                 new TilingTypeN5_01ak(),
                                 new TilingTypeN5_01am1(),
                                 new TilingTypeN5_01am2(),
                                 new TilingTypeN5_01ay(),
                                 new TilingTypeN5_01bc(),
                                 new TilingTypeN5_01be(),
                                 new TilingTypeN5_02a(),
                                 new TilingTypeN5_02b(),
                                 new TilingTypeN5_02c(),
                                 new TilingTypeN5_02e(),
                                 new TilingTypeN5_02f(),
                                 new TilingTypeN5_02g(),
                                 new TilingTypeN5_02h(),
                                 new TilingTypeN5_01k2(),
                                 new TilingTypeN5_01k3(),
                                 new TilingTypeN5_01l2(),
                                 new TilingTypeN5_01l3(),
                                 new TilingTypeN5_01bo(),
                                 new TilingTypeN5_01bp(),
                                 new TilingTypeN5_01br1(),
                                 new TilingTypeN5_01br2(),
                                 new TilingTypeN5_01br3(),
                                 new TilingTypeN5_01br4(),
                                 new TilingTypeN5_01br5(),
                                 new TilingTypeN5_01br6(),
                                 new TilingTypeN5_01br7(),
                                 new TilingTypeN5_01br8(),
                                 new TilingTypeN5_01br9(),
                                 new TilingTypeN5_01br10(),
                                 new TilingTypeN5_01bs1(),
                                 new TilingTypeN5_01bs2(),
                                 new TilingTypeN5_01bt(),
                                 new TilingTypeN5_01bw(),
                                 new TilingTypeN5_01bx1(),
                                 new TilingTypeN5_01bx3(),
                                 new TilingTypeN5_01bx4(),
                                 new TilingTypeN5_02d(),
                                 new TilingTypeN5_08b(),
                           },
                           new Object[]{
                                 "Type 3",
                                 new TilingTypeP5_13(),
                                 new TilingTypeN5_03a(),
                                 new TilingTypeN5_03b(),
                                 new TilingTypeN5_03c(),
                                 new TilingTypeN5_03d(),
                           },
                           new Object[]{
                                 "Type 4",
                                 new TilingTypeP5_23(),
                                 new TilingTypeN5_04b(),
                           },
                           new Object[]{
                                 "Type 5",
                                 new TilingTypeP5_16(),
                                 new TilingTypeN5_01r1(),
                                 new TilingTypeN5_01r2(),
                                 new TilingTypeN5_01r3(),
                                 new TilingTypeN5_01r4(),
                                 new TilingTypeN5_01r5(),
                                 new TilingTypeN5_01r6(),
                                 new TilingTypeN5_01s(),
                           },
                           new Object[]{
                                 "Type 6",
                                 new TilingTypeN5_06a(),
                                 new TilingTypeN5_06b(),
                           },
                           new Object[]{
                                 "Type 7",
                                 new TilingTypeN5_07(),
                           },
                           new Object[]{
                                 "Type 8",
                                 new TilingTypeN5_08a(),
                                 new TilingTypeN5_01bl(),
                                 new TilingTypeN5_08b(),
                           },
                           new Object[]{
                                 "Type 9",
                                 new TilingTypeN5_09(),
                           },
                           new Object[]{
                                 "Type 10",
                                 new TilingTypeN5_10(),
                           },
                           new Object[]{
                                 "Type 11",
                                 new TilingTypeN5_11(),
                           },
                           new Object[]{
                                 "Type 12",
                                 new TilingTypeN5_12(),
                           },
                           new Object[]{
                                 "Type 13",
                                 new TilingTypeN5_13(),
                           },
                           new Object[]{
                                 "Type 14",
                                 new TilingTypeN5_14(),
                           },
                           new Object[]{
                                 "Type 15",
                                 new TilingTypeN5_15(),
                           },
                     },new Object[]{
                           "By isohedrality",
                           new Object[]{
                                 "Isohedral *",
                                 new TilingTypeP5_01(),
                                 new TilingTypeP5_02(),
                                 new TilingTypeP5_03(),
                                 new TilingTypeP5_03b(),
                                 new TilingTypeP5_04(),
                                 new TilingTypeP5_05(),
                                 new TilingTypeP5_06(),
                                 new TilingTypeP5_07(),
                                 new TilingTypeP5_08(),
                                 new TilingTypeP5_09(),
                                 new TilingTypeP5_10(),
                                 new TilingTypeP5_12(),
                                 new TilingTypeP5_13(),
                                 new TilingTypeP5_16(),
                                 new TilingTypeP5_17(),
                                 new TilingTypeP5_19(),
                                 new TilingTypeP5_22(),
                                 new TilingTypeP5_23(),
                           },new Object[]{
                                 "2-isohedral, 1:1 *",
                                 new Object[]{
                                       "Type 1 *",
                                       new TilingTypeN5_01a1(),
                                       new TilingTypeN5_01a2(),
                                       new TilingTypeN5_01a3(),
                                       new TilingTypeN5_01a4(),
                                       new TilingTypeN5_01b1(),
                                       new TilingTypeN5_01b2(),
                                       new TilingTypeN5_01b3(),
                                       new TilingTypeN5_01b4(),
                                       new TilingTypeN5_01b5(),
                                       new TilingTypeN5_01b6(),
                                       new TilingTypeN5_01c(),
                                       new TilingTypeN5_01d(),
                                       new TilingTypeN5_01e1(),
                                       new TilingTypeN5_01e2(),
                                       new TilingTypeN5_01f(),
                                       new TilingTypeN5_01g(),
                                       new TilingTypeN5_01h(),
                                       new TilingTypeN5_01i(),
                                       new TilingTypeN5_01j1(),
                                       new TilingTypeN5_01j2(),
                                       new TilingTypeN5_01k1(),
                                       new TilingTypeN5_01l1(),
                                       new TilingTypeN5_01m(),
                                       new TilingTypeN5_01n(),
                                       new TilingTypeN5_01o1(),
                                       new TilingTypeN5_01o2(),
                                       new TilingTypeN5_01o3(),
                                       new TilingTypeN5_01o4(),
                                       new TilingTypeN5_01o5(),
                                       new TilingTypeN5_01o6(),
                                       new TilingTypeN5_01o7(),
                                       new TilingTypeN5_01o8(),
                                       new TilingTypeN5_01o9(),
                                       new TilingTypeN5_01p1(),
                                       new TilingTypeN5_01p2(),
                                       new TilingTypeN5_01q1(),
                                       new TilingTypeN5_01q2(),
                                       new TilingTypeN5_01t(),
                                       new TilingTypeN5_01u(),
                                       new TilingTypeN5_01v(),
                                       new TilingTypeN5_01w(),
                                       new TilingTypeN5_01x(),
                                       new TilingTypeN5_01y(),
                                       new TilingTypeN5_01z1(),
                                       new TilingTypeN5_01z2(),
                                       new TilingTypeN5_01aa(),
                                       new TilingTypeN5_01ab1(),
                                       new TilingTypeN5_01ab2(),
                                       new TilingTypeN5_01ac1(),
                                       new TilingTypeN5_01ac2(),
                                       new TilingTypeN5_01ad(),
                                       new TilingTypeN5_01ae(),
                                       new TilingTypeN5_01af(),
                                       new TilingTypeN5_01ag1(),
                                       new TilingTypeN5_01ag2(),
                                       new TilingTypeN5_01ah(),
                                       new TilingTypeN5_01ai(),
                                       new TilingTypeN5_01aj(),
                                       new TilingTypeN5_01ak(),
                                       new TilingTypeN5_01al(),
                                       new TilingTypeN5_01am1(),
                                       new TilingTypeN5_01am2(),
                                       new TilingTypeN5_01an(),
                                       new TilingTypeN5_01ao(),
                                       new TilingTypeN5_01ap(),
                                       new TilingTypeN5_01aq(),
                                       new TilingTypeN5_01ar(),
                                       new TilingTypeN5_01as(),
                                       new TilingTypeN5_01at(),
                                       new TilingTypeN5_01au(),
                                       new TilingTypeN5_01av(),
                                       new TilingTypeN5_01aw(),
                                       new TilingTypeN5_01ax(),
                                       new TilingTypeN5_01ay(),
                                       new TilingTypeN5_01az(),
                                       new TilingTypeN5_01ba(),
                                       new TilingTypeN5_01bb(),
                                       new TilingTypeN5_01bc(),
                                       new TilingTypeN5_01bd(),
                                       new TilingTypeN5_01be(),
                                       new TilingTypeN5_01br1(),
                                 },new Object[]{
                                       "Type 2 *",
                                       new TilingTypeN5_02a(),
                                       new TilingTypeN5_02b(),
                                       new TilingTypeN5_02c(),
                                       new TilingTypeN5_02e(),
                                       new TilingTypeN5_02f(),
                                       new TilingTypeN5_02g(),
                                       new TilingTypeN5_02h(),
                                 },new Object[]{
                                       "Other *",
                                       new TilingTypeN5_04b(),
                                       new TilingTypeN5_06a(),
                                       new TilingTypeN5_06b(),
                                       new TilingTypeN5_07(),
                                       new TilingTypeN5_08a(),
                                       new TilingTypeN5_09(),
                                       new TilingTypeN5_11(),
                                       new TilingTypeN5_12(),
                                       new TilingTypeN5_13(),
                                 },
                           },new Object[]{
                                 "3-isohedral",
                                 new TilingTypeN5_01k2(),
                                 new TilingTypeN5_01k3(),
                                 new TilingTypeN5_01l2(),
                                 new TilingTypeN5_01l3(),
                                 new TilingTypeN5_01r1(),
                                 new TilingTypeN5_01r2(),
                                 new TilingTypeN5_01r3(),
                                 new TilingTypeN5_01r4(),
                                 new TilingTypeN5_01r5(),
                                 new TilingTypeN5_01r6(),
                                 new TilingTypeN5_01s(),
                                 new TilingTypeN5_01bf1(),
                                 new TilingTypeN5_01bg1(),
                                 new TilingTypeN5_01bg2(),
                                 new TilingTypeN5_01bh(),
                                 new TilingTypeN5_01bi(),
                                 new TilingTypeN5_01bj(),
                                 new TilingTypeN5_01bk(),
                                 new TilingTypeN5_01bl(),
                                 new TilingTypeN5_01bm(),
                                 new TilingTypeN5_01bn(),
                                 new TilingTypeN5_01bo(),
                                 new TilingTypeN5_01bp(),
                                 new TilingTypeN5_01bq1(),
                                 new TilingTypeN5_01bq2(),
                                 new TilingTypeN5_01br2(),
                                 new TilingTypeN5_01br3(),
                                 new TilingTypeN5_01br4(),
                                 new TilingTypeN5_01bs1(),
                                 new TilingTypeN5_01bs2(),
                                 new TilingTypeN5_01bt(),
                                 new TilingTypeN5_01bu(),
                                 new TilingTypeN5_01bv(),
                                 new TilingTypeN5_01bw(),
                                 new TilingTypeN5_02d(),
                                 new TilingTypeN5_03a(),
                                 new TilingTypeN5_03b(),
                                 new TilingTypeN5_03c(),
                                 new TilingTypeN5_03d(),
                                 new TilingTypeN5_10(),
                                 new TilingTypeN5_14(),
                                 new TilingTypeN5_15(),
                           },new Object[]{
                                 "4-isohedral",
                                 new TilingTypeN5_01ac3(),
                                 new TilingTypeN5_01ac4(),
                                 new TilingTypeN5_01ac5(),
                                 new TilingTypeN5_01ac6(),
                                 new TilingTypeN5_01bf2(),
                                 new TilingTypeN5_01br5(),
                                 new TilingTypeN5_01bx1(),
                                 new TilingTypeN5_08b(),
                           },new Object[]{
                                 "6-isohedral",
                                 new TilingTypeN5_01ac7(),
                                 new TilingTypeN5_01ac8(),
                                 new TilingTypeN5_01br6(),
                                 new TilingTypeN5_01br7(),
                                 new TilingTypeN5_01br8(),
                                 new TilingTypeN5_01br9(),
                                 new TilingTypeN5_01br10(),
                                 new TilingTypeN5_01bx3(),
                                 new TilingTypeN5_01bx4(),
                           },
                     },new Object[]{
                           "15 convex pentagon tile types",
                           new TilingTypeP5_04(),
                           new TilingTypeP5_10(),
                           new TilingTypeP5_13(),
                           new TilingTypeP5_23(),
                           new TilingTypeP5_16(),
                           new TilingTypeN5_06a(),
                           new TilingTypeN5_07(),
                           new TilingTypeN5_08a(),
                           new TilingTypeN5_09(),
                           new TilingTypeN5_10(),
                           new TilingTypeN5_11(),
                           new TilingTypeN5_12(),
                           new TilingTypeN5_13(),
                           new TilingTypeN5_14(),
                           new TilingTypeN5_15(),
                     },
               },new Object[]{
                     "Non-Convex",
                     new Object[]{
                           "Isohedral *",
                           new TilingTypeNC5_11a(),
                           new TilingTypeNC5_11b(),
                           new TilingTypeNC5_14a(),
                           new TilingTypeNC5_19(),
                           new TilingTypeNC5_20a(),
                           new TilingTypeNC5_20b(),
                           new TilingTypeNC5_25a(),
                           new TilingTypeNC5_41(),
                           new TilingTypeNC5_42(),
                           new TilingTypeNC5_43a(),
                           new TilingTypeNC5_43b(),
                           new TilingTypeNC5_43c(),
                           new TilingTypeNC5_43d(),
                           new TilingTypeNC5_48(),
                           new TilingTypeNC5_50(),
                           new TilingTypeNC5_51a(),
                           new TilingTypeNC5_52a(),
                           new TilingTypeNC5_53a(),
                           new TilingTypeNC5_54(),
                           new TilingTypeNC5_60a(),
                           new TilingTypeNC5_63a(),
                           new TilingTypeNC5_63b(),
                           new TilingTypeNC5_63c(),
                           new TilingTypeNC5_66a(),
                           new TilingTypeNC5_75(),
                           new TilingTypeNC5_76a(),
                           new TilingTypeNC5_77(),
                           new TilingTypeNC5_78a(),
                     },new Object[]{
                           "2-isohedral, 1:1 *",
                           new Object[]{
                                 "Type 1",
                                 new TilingTypeNC5_07a(),
                                 new TilingTypeNC5_07b(),
                                 new TilingTypeNC5_08a(),
                                 new TilingTypeNC5_08b(),
                                 new TilingTypeNC5_08c(),
                                 new TilingTypeNC5_08d(),
                                 new TilingTypeNC5_08e(),
                                 new TilingTypeNC5_08f(),
                                 new TilingTypeNC5_08g(),
                                 new TilingTypeNC5_08h(),
                                 new TilingTypeNC5_08i(),
                                 new TilingTypeNC5_14b(),
                                 new TilingTypeNC5_21a(),
                                 new TilingTypeNC5_21b(),
                                 new TilingTypeNC5_21c(),
                                 new TilingTypeNC5_21d(),
                                 new TilingTypeNC5_22(),
                                 new TilingTypeNC5_23a(),
                                 new TilingTypeNC5_23b(),
                                 new TilingTypeNC5_24a(),
                                 new TilingTypeNC5_24b(),
                                 new TilingTypeNC5_25b(),
                                 new TilingTypeNC5_26(),
                                 new TilingTypeNC5_27a(),
                                 new TilingTypeNC5_27b(),
                                 new TilingTypeNC5_28(),
                                 new TilingTypeNC5_30a(),
                                 new TilingTypeNC5_30b(),
                                 new TilingTypeNC5_31(),
                                 new TilingTypeNC5_32a(),
                                 new TilingTypeNC5_32b(),
                                 new TilingTypeNC5_33a(),
                                 new TilingTypeNC5_33b(),
                                 new TilingTypeNC5_34(),
                                 new TilingTypeNC5_35(),
                                 new TilingTypeNC5_36(),
                                 new TilingTypeNC5_37(),
                                 new TilingTypeNC5_38(),
                                 new TilingTypeNC5_39a(),
                                 new TilingTypeNC5_39b(),
                                 new TilingTypeNC5_40(),
                                 new TilingTypeNC5_43e(),
                                 new TilingTypeNC5_43f(),
                                 new TilingTypeNC5_43g(),
                                 new TilingTypeNC5_43h(),
                                 new TilingTypeNC5_43i(),
                                 new TilingTypeNC5_43j(),
                                 new TilingTypeNC5_51b(),
                                 new TilingTypeNC5_52b(),
                                 new TilingTypeNC5_53b(),
                                 new TilingTypeNC5_66b(),
                                 new TilingTypeNC5_76b(),
                                 new TilingTypeNC5_76c(),
                                 new TilingTypeNC5_78b(),
                                 new TilingTypeNC5_78c(),
                                 new TilingTypeNC5_78d(),
                                 new TilingTypeNC5_78e(),
                                 new TilingTypeNC5_79(),
                                 new TilingTypeNC5_80(),
                                 new TilingTypeNC5_81(),
                                 new TilingTypeNC5_83(),
                                 new TilingTypeNC5_84(),
                                 new TilingTypeNC5_88(),
                                 new TilingTypeNC5_91(),
                                 new TilingTypeNC5_94(),
                                 new TilingTypeNC5_95a(),
                                 new TilingTypeNC5_96(),
                                 new TilingTypeNC5_97(),
                                 new TilingTypeNC5_98(),
                                 new TilingTypeNC5_99(),
                                 new TilingTypeNC5_100(),
                                 new TilingTypeNC5_101(),
                                 new TilingTypeNC5_104(),
                                 new TilingTypeNC5_105(),
                                 new TilingTypeNC5_106(),
                                 new TilingTypeNC5_110(),
                                 new TilingTypeNC5_112a(),
                                 new TilingTypeNC5_112b(),
                                 new TilingTypeNC5_113(),
                                 new TilingTypeNC5_114(),
                                 new TilingTypeNC5_115(),
                                 new TilingTypeNC5_117(),
                                 new TilingTypeNC5_118(),
                                 new TilingTypeNC5_121(),
                                 new TilingTypeNC5_122a(),
                                 new TilingTypeNC5_122b(),
                                 new TilingTypeNC5_125(),
                                 new TilingTypeNC5_126(),
                                 new TilingTypeNC5_127(),
                                 new TilingTypeNC5_128(),
                                 new TilingTypeNC5_132(),
                                 new TilingTypeNC5_134(),
                                 new TilingTypeNC5_136(),
                                 new TilingTypeNC5_137(),
                                 new TilingTypeNC5_138(),
                                 new TilingTypeNC5_139(),
                                 new TilingTypeNC5_140(),
                                 new TilingTypeNC5_141(),
                                 new TilingTypeNC5_143(),
                                 new TilingTypeNC5_144(),
                                 new TilingTypeNC5_145(),
                                 new TilingTypeNC5_146(),
                                 new TilingTypeNC5_149(),
                                 new TilingTypeNC5_150(),
                                 new TilingTypeNC5_153(),
                                 new TilingTypeNC5_155(),
                                 new TilingTypeNC5_156(),
                                 new TilingTypeNC5_157(),
                                 new TilingTypeNC5_158(),
                                 new TilingTypeNC5_159(),
                                 new TilingTypeNC5_160(),
                                 new TilingTypeNC5_161(),
                                 new TilingTypeNC5_162(),
                                 new TilingTypeNC5_163(),
                                 new TilingTypeNC5_164(),
                                 new TilingTypeNC5_166(),
                                 new TilingTypeNC5_168(),
                                 new TilingTypeNC5_169(),
                                 new TilingTypeNC5_170(),
                                 new TilingTypeNC5_171(),
                                 new TilingTypeNC5_172(),
                                 new TilingTypeNC5_173(),
                                 new TilingTypeNC5_174(),
                                 new TilingTypeNC5_175a(),
                                 new TilingTypeNC5_175b(),
                                 new TilingTypeNC5_175c(),
                                 new TilingTypeNC5_176(),
                                 new TilingTypeNC5_177(),
                                 new TilingTypeNC5_178(),
                                 new TilingTypeNC5_179a(),
                                 new TilingTypeNC5_179b(),
                                 new TilingTypeNC5_180(),
                                 new TilingTypeNC5_181(),
                                 new TilingTypeNC5_182(),
                                 new TilingTypeNC5_183(),
                                 new TilingTypeNC5_184(),
                                 new TilingTypeNC5_185(),
                                 new TilingTypeNC5_186(),
                                 new TilingTypeNC5_187(),
                                 new TilingTypeNC5_188(),
                                 new TilingTypeNC5_189(),
                                 new TilingTypeNC5_190a(),
                                 new TilingTypeNC5_190b(),
                                 new TilingTypeNC5_191(),
                                 new TilingTypeNC5_192(),
                                 new TilingTypeNC5_194(),
                                 new TilingTypeNC5_195(),
                                 new TilingTypeNC5_196(),
                                 new TilingTypeNC5_197(),
                                 new TilingTypeNC5_198(),
                                 new TilingTypeNC5_199(),
                                 new TilingTypeNC5_200(),
                                 new TilingTypeNC5_201(),
                                 new TilingTypeNC5_202(),
                                 new TilingTypeNC5_203(),
                                 new TilingTypeNC5_204(),
                                 new TilingTypeNC5_205a(),
                                 new TilingTypeNC5_205b(),
                                 new TilingTypeNC5_206(),
                                 new TilingTypeNC5_207(),
                                 new TilingTypeNC5_208a(),
                                 new TilingTypeNC5_208b(),
                                 new TilingTypeNC5_210a(),
                                 new TilingTypeNC5_210b(),
                                 new TilingTypeNC5_211(),
                                 new TilingTypeNC5_212(),
                                 new TilingTypeNC5_213(),
                                 new TilingTypeNC5_214(),
                                 new TilingTypeNC5_216(),
                           },new Object[]{
                                 "Type 2",
                                 new TilingTypeNC5_01a(),
                                 new TilingTypeNC5_01b(),
                                 new TilingTypeNC5_02a(),
                                 new TilingTypeNC5_02b(),
                                 new TilingTypeNC5_02c(),
                                 new TilingTypeNC5_02d(),
                                 new TilingTypeNC5_03(),
                                 new TilingTypeNC5_05a(),
                                 new TilingTypeNC5_05b(),
                                 new TilingTypeNC5_06a(),
                                 new TilingTypeNC5_06b(),
                                 new TilingTypeNC5_06c(),
                                 new TilingTypeNC5_10a(),
                                 new TilingTypeNC5_10b(),
                                 new TilingTypeNC5_13(),
                                 new TilingTypeNC5_15(),
                                 new TilingTypeNC5_56(),
                                 new TilingTypeNC5_57a(),
                                 new TilingTypeNC5_57b(),
                                 new TilingTypeNC5_57c(),
                                 new TilingTypeNC5_57d(),
                                 new TilingTypeNC5_57e(),
                                 new TilingTypeNC5_57h(),
                                 new TilingTypeNC5_57i(),
                                 new TilingTypeNC5_58b(),
                                 new TilingTypeNC5_58c(),
                                 new TilingTypeNC5_58d(),
                                 new TilingTypeNC5_58e(),
                                 new TilingTypeNC5_60b(),
                                 new TilingTypeNC5_62a(),
                                 new TilingTypeNC5_62b(),
                                 new TilingTypeNC5_62c(),
                                 new TilingTypeNC5_62d(),
                                 new TilingTypeNC5_62e(),
                                 new TilingTypeNC5_62f(),
                                 new TilingTypeNC5_63d(),
                                 new TilingTypeNC5_63e(),
                                 new TilingTypeNC5_63f(),
                                 new TilingTypeNC5_63g(),
                                 new TilingTypeNC5_64(),
                                 new TilingTypeNC5_65(),
                                 new TilingTypeNC5_67(),
                                 new TilingTypeNC5_68a(),
                                 new TilingTypeNC5_68b(),
                                 new TilingTypeNC5_69a(),
                                 new TilingTypeNC5_69b(),
                                 new TilingTypeNC5_69c(),
                                 new TilingTypeNC5_90a(),
                                 new TilingTypeNC5_90b(),
                                 new TilingTypeNC5_90c(),
                                 new TilingTypeNC5_92(),
                                 new TilingTypeNC5_102(),
                                 new TilingTypeNC5_111(),
                                 new TilingTypeNC5_116(),
                                 new TilingTypeNC5_119a(),
                                 new TilingTypeNC5_119b(),
                                 new TilingTypeNC5_123a(),
                                 new TilingTypeNC5_123b(),
                                 new TilingTypeNC5_124(),
                                 new TilingTypeNC5_129(),
                                 new TilingTypeNC5_142(),
                                 new TilingTypeNC5_151(),
                                 new TilingTypeNC5_154(),
                                 new TilingTypeNC5_193(),
                                 new TilingTypeNC5_209(),
                                 new TilingTypeNC5_215(),
                                 new TilingTypeNC5_217(),
                           },new Object[]{
                                 "Type 1+2",
                                 new TilingTypeNC5_29a(),
                                 new TilingTypeNC5_29b(),
                                 new TilingTypeNC5_29c(),
                                 new TilingTypeNC5_55a(),
                                 new TilingTypeNC5_55b(),
                                 new TilingTypeNC5_55c(),
                                 new TilingTypeNC5_55d(),
                                 new TilingTypeNC5_70(),
                           },new Object[]{
                                 "Other",
                                 new TilingTypeNC5_04(),
                                 new TilingTypeNC5_16(),
                                 new TilingTypeNC5_20c(),
                                 new TilingTypeNC5_20d(),
                                 new TilingTypeNC5_20e(),
                                 new TilingTypeNC5_58a(),
                                 new TilingTypeNC5_61(),
                                 new TilingTypeNC5_71a(),
                                 new TilingTypeNC5_72a(),
                                 new TilingTypeNC5_72b(),
                                 new TilingTypeNC5_73a(),
                                 new TilingTypeNC5_73b(),
                                 new TilingTypeNC5_73c(),
                                 new TilingTypeNC5_74(),
                                 new TilingTypeNC5_82(),
                                 new TilingTypeNC5_85(),
                                 new TilingTypeNC5_86(),
                                 new TilingTypeNC5_87(),
                                 new TilingTypeNC5_89(),
                                 new TilingTypeNC5_93(),
                                 new TilingTypeNC5_103(),
                                 new TilingTypeNC5_107(),
                                 new TilingTypeNC5_108(),
                                 new TilingTypeNC5_109(),
                                 new TilingTypeNC5_120(),
                                 new TilingTypeNC5_130(),
                                 new TilingTypeNC5_131(),
                                 new TilingTypeNC5_133(),
                                 new TilingTypeNC5_135(),
                                 new TilingTypeNC5_147(),
                                 new TilingTypeNC5_148(),
                                 new TilingTypeNC5_152(),
                                 new TilingTypeNC5_165(),
                                 new TilingTypeNC5_167(),
                           },
                     },new Object[]{
                           "3-isohedral",
                           new TilingTypeNC5_17a(),
                           new TilingTypeNC5_17b(),
                           new TilingTypeNC5_17c(),
                           new TilingTypeNC5_17d(),
                           new TilingTypeNC5_18a(),
                           new TilingTypeNC5_18b(),
                           new TilingTypeNC5_71b(),
                           new TilingTypeNC5_71c(),

                           new TilingTypeNC5_57j(),
                           new TilingTypeNC5_57k(),
                           new TilingTypeNC5_57l(),
                           new TilingTypeNC5_218(),
                           new TilingTypeNC5_219a(),
                           new TilingTypeNC5_219b(),
                           new TilingTypeNC5_219c(),
                           new TilingTypeNC5_220(),
                           new TilingTypeNC5_221(),
                           new TilingTypeNC5_222(),
                           new TilingTypeNC5_223(),
                           new TilingTypeNC5_224(),
                           new TilingTypeNC5_225(),
                           new TilingTypeNC5_226a(),
                           new TilingTypeNC5_226b(),
                           new TilingTypeNC5_226c(),
                           new TilingTypeNC5_226d(),
                           new TilingTypeNC5_62g(),
                           new TilingTypeNC5_228(),
                           new TilingTypeNC5_229a(),
                           new TilingTypeNC5_229b(),
                           new TilingTypeNC5_230(),
                           new TilingTypeNC5_231a(),
                           new TilingTypeNC5_231b(),
                           new TilingTypeNC5_232a(),
                           new TilingTypeNC5_232b(),
                           new TilingTypeNC5_233a(),
                           new TilingTypeNC5_233b(),
                           new TilingTypeNC5_233c(),
                           new TilingTypeNC5_234(),
                           new TilingTypeNC5_235(),
                           new TilingTypeNC5_236(),
                           new TilingTypeNC5_72c(),
                           new TilingTypeNC5_237(),
                           new TilingTypeNC5_238(),
                           new TilingTypeNC5_239(),
                           new TilingTypeNC5_240(),
                           new TilingTypeNC5_241(),
                           new TilingTypeNC5_95b(),
                           new TilingTypeNC5_57m(),
                           new TilingTypeNC5_57n(),
                           new TilingTypeNC5_57o(),
                           new TilingTypeNC5_242(),
                           new TilingTypeNC5_243(),
                           new TilingTypeNC5_244(),
                           new TilingTypeNC5_245(),
                           new TilingTypeNC5_246a(),
                           new TilingTypeNC5_246b(),
                           new TilingTypeNC5_247(),
                           new TilingTypeNC5_248(),
                           new TilingTypeNC5_249(),
                           new TilingTypeNC5_62h(),
                           new TilingTypeNC5_250(),
                           new TilingTypeNC5_251(),
                           new TilingTypeNC5_252(),
                           new TilingTypeNC5_253a(),
                           new TilingTypeNC5_253b(),
                           new TilingTypeNC5_254(),
                           new TilingTypeNC5_255(),
                           new TilingTypeNC5_256(),
                           new TilingTypeNC5_257(),
                           new TilingTypeNC5_258a(),
                           new TilingTypeNC5_258b(),
                           new TilingTypeNC5_258c(),
                           new TilingTypeNC5_259a(),
                           new TilingTypeNC5_259b(),
                           new TilingTypeNC5_259c(),
                           new TilingTypeNC5_259d(),
                           new TilingTypeNC5_260a(),
                           new TilingTypeNC5_260b(),
                           new TilingTypeNC5_260c(),
                           new TilingTypeNC5_261(),
                           new TilingTypeNC5_262(),
                           new TilingTypeNC5_263(),
                           new TilingTypeNC5_08j(),
                           new TilingTypeNC5_264(),
                           new TilingTypeNC5_265(),
                           new TilingTypeNC5_266(),
                           new TilingTypeNC5_267a(),
                           new TilingTypeNC5_267b(),
                           new TilingTypeNC5_268(),
                           new TilingTypeNC5_69d(),
                           new TilingTypeNC5_182b(),
                           new TilingTypeNC5_182c(),
                           new TilingTypeNC5_269(),
                           new TilingTypeNC5_72c(),
                           new TilingTypeNC5_72d(),
                           new TilingTypeNC5_270(),
                           new TilingTypeNC5_271(),
                           new TilingTypeNC5_73d(),
                           new TilingTypeNC5_272(),
                           new TilingTypeNC5_273(),
                           new TilingTypeNC5_274(),
                           new TilingTypeNC5_275(),
                           new TilingTypeNC5_276(),

                     
                     },new Object[]{
                           "4-isohedral",
                           new TilingTypeNC5_49a(),
                           new TilingTypeNC5_49b(),
                           new TilingTypeNC5_49c(),
                           new TilingTypeNC5_49d(),
                           new TilingTypeNC5_49e(),
                           new TilingTypeNC5_49f(),
                           new TilingTypeNC5_49g(),
                           new TilingTypeNC5_49h(),
                           new TilingTypeNC5_49i(),
                           new TilingTypeNC5_49j(),
                           new TilingTypeNC5_49k(),
                           new TilingTypeNC5_49l(),
                           new TilingTypeNC5_49m(),
                           new TilingTypeNC5_49n(),
                           new TilingTypeNC5_73e(),
                     },new Object[]{
                           "17 non-convex pentagon tile types",
                           new TilingTypeNC5_50(),
                           new TilingTypeNC5_42(),
                           new TilingTypeNC5_11a(),
                           new TilingTypeNC5_20a(),
                           new TilingTypeNC5_19(),
                           new TilingTypeNC5_04(),
                           new TilingTypeNC5_16(),
                           new TilingTypeNC5_18a(),
                           new TilingTypeNC5_58a(),
                           new TilingTypeNC5_61(),
                           new TilingTypeNC5_73a(),
                           new TilingTypeNC5_74(),
                           new TilingTypeNC5_109(),
                           new TilingTypeNC5_120(),
                           new TilingTypeNC5_147(),
                           new TilingTypeNC5_148(),
                           new TilingTypeNC5_152(),
                     },
               },
         },new Object[]{
               "Hexagon Tilings",
               new Object[]{
                     "Convex",
                     new Object[]{
                           "By type",
                           new Object[]{
                                 "Type 1",
                                 new TilingTypeP6_01(),
                                 new TilingTypeP6_02(),
                                 new TilingTypeP6_03(),
                                 new TilingTypeP6_04(),
                                 new TilingTypeN6_01(),
                                 new TilingTypeN6_02(),
                                 new TilingTypeN6_03a(),
                                 new TilingTypeN6_04(),
                                 new TilingTypeN6_05a(),
                                 new TilingTypeN6_06a(),
                                 new TilingTypeN6_09b(),
                                 new TilingTypeN6_09h(),
                                 new TilingTypeN6_03b(),
                                 new TilingTypeN6_05b(),
                                 new TilingTypeN6_05c(),
                                 new TilingTypeN6_06b(),
                                 new TilingTypeN6_06c(),
                                 new TilingTypeN6_07a(),
                                 new TilingTypeN6_07b(),
                                 new TilingTypeN6_09a(),
                                 new TilingTypeN6_09c(),
                                 new TilingTypeN6_09d(),
                                 new TilingTypeN6_09e(),
                                 new TilingTypeN6_09f(),
                                 new TilingTypeN6_09g(),
                           },
                           new Object[]{
                                 "Type 2",
                                 new TilingTypeP6_05(),
                                 new TilingTypeN6_03a(),
                                 new TilingTypeN6_05a(),
                                 new TilingTypeN6_06a(),
                                 new TilingTypeN6_03b(),
                                 new TilingTypeN6_05b(),
                                 new TilingTypeN6_05c(),
                                 new TilingTypeN6_06b(),
                                 new TilingTypeN6_06c(),
                           },
                           new Object[]{
                                 "Type 3",
                                 new TilingTypeP6_06(),
                           },
                     },
                     new Object[]{
                           "By isohedrality",
                           new Object[]{
                                 "Isohedral *",
                                 new TilingTypeP6_01(),
                                 new TilingTypeP6_02(),
                                 new TilingTypeP6_03(),
                                 new TilingTypeP6_04(),
                                 new TilingTypeP6_05(),
                                 new TilingTypeP6_06(),
                           },
                           new Object[]{
                                 "2-Isohedral, 1:1 *",
                                 new TilingTypeN6_01(),
                                 new TilingTypeN6_02(),
                                 new TilingTypeN6_03a(),
                                 new TilingTypeN6_04(),
                                 new TilingTypeN6_05a(),
                                 new TilingTypeN6_06a(),
                           },
                           new Object[]{
                                 "2-Isohedral, 2:1",
                                 new TilingTypeN6_09b(),
                                 new TilingTypeN6_09h(),
                           },
                           new Object[]{
                                 "3-Isohedral",
                                 new TilingTypeN6_03b(),
                                 new TilingTypeN6_05b(),
                                 new TilingTypeN6_05c(),
                                 new TilingTypeN6_06b(),
                                 new TilingTypeN6_06c(),
                                 new TilingTypeN6_07a(),
                                 new TilingTypeN6_07b(),
                                 new TilingTypeN6_09a(),
                                 new TilingTypeN6_09c(),
                                 new TilingTypeN6_09d(),
                                 new TilingTypeN6_09e(),
                                 new TilingTypeN6_09f(),
                                 new TilingTypeN6_09g(),
                           },
                     },
                     new Object[]{
                           "3 convex hexagon tile types",
                           new TilingTypeP6_03(),
                           new TilingTypeP6_05(),
                           new TilingTypeP6_06(),
                     }
               },
               new Object[]{
                     "Non-Convex",
                     new Object[]{
                           "Isohedral",
                           new TilingTypeNC6_73(),
                           new TilingTypeNC6_74(),
                           new TilingTypeNC6_75(),
                           new TilingTypeNC6_76a(),
                           new TilingTypeNC6_76b(),
                           new TilingTypeNC6_77a(),
                           new TilingTypeNC6_77b(),
                           new TilingTypeNC6_78(),
                           new TilingTypeNC6_79a(),
                           new TilingTypeNC6_79b(),
                           new TilingTypeNC6_79c(),
                           new TilingTypeNC6_79d(),
                           new TilingTypeNC6_79e(),
                           new TilingTypeNC6_79f(),
                           new TilingTypeNC6_79g(),
                           new TilingTypeNC6_79h(),
                           new TilingTypeNC6_80(),
                           new TilingTypeNC6_81a(),
                           new TilingTypeNC6_81b(),
                           new TilingTypeNC6_81c(),
                           new TilingTypeNC6_81d(),
                           new TilingTypeNC6_81e(),
                           new TilingTypeNC6_81f(),
                           new TilingTypeNC6_82(),
                           new TilingTypeNC6_83a(),
                           new TilingTypeNC6_83b(),
                           new TilingTypeNC6_85(),
                           new TilingTypeNC6_86(),

                           new TilingTypeNC6_87(),
                           new TilingTypeNC6_88(),
                           new TilingTypeNC6_89(),
                           new TilingTypeNC6_90(),
                           new TilingTypeNC6_91(),
                           new TilingTypeNC6_92(),

                           new TilingTypeNC6_93a(),
                           new TilingTypeNC6_93b(),
                           new TilingTypeNC6_93c(),
                           new TilingTypeNC6_94a(),
                           new TilingTypeNC6_94b(),
                           new TilingTypeNC6_94c(),

                           new TilingTypeNC6_95a(),
                           new TilingTypeNC6_95b(),
                           new TilingTypeNC6_95c(),
                           new TilingTypeNC6_96(),
                           new TilingTypeNC6_97(),
                           new TilingTypeNC6_98(),
                     },
                     new Object[]{
                           "2-Isohedral, 1:1 +",
                           new TilingTypeNC6_01(),
                           new TilingTypeNC6_02a(),
                           new TilingTypeNC6_02b(),
                           new TilingTypeNC6_02c(),
                           new TilingTypeNC6_02d(),
                           new TilingTypeNC6_03a(),
                           new TilingTypeNC6_03b(),
                           new TilingTypeNC6_04(),
                           new TilingTypeNC6_05a(),
                           new TilingTypeNC6_05b(),
                           new TilingTypeNC6_06a(),
                           new TilingTypeNC6_06b(),
                           new TilingTypeNC6_06c(),
                           new TilingTypeNC6_06d(),
                           new TilingTypeNC6_06e(),
                           new TilingTypeNC6_06f(),
                           new TilingTypeNC6_06g(),
                           new TilingTypeNC6_07a(),
                           new TilingTypeNC6_07b(),
                           new TilingTypeNC6_07c(),
                           new TilingTypeNC6_07d(),
                           new TilingTypeNC6_07e(),
                           new TilingTypeNC6_07f(),
                           new TilingTypeNC6_07g(),
                           new TilingTypeNC6_07h(),
                           new TilingTypeNC6_08(),
                           new TilingTypeNC6_09(),
                           new TilingTypeNC6_10(),
                           new TilingTypeNC6_11(),
                           new TilingTypeNC6_12(),
                           new TilingTypeNC6_13(),
                           new TilingTypeNC6_14(),
                           new TilingTypeNC6_15a(),
                           new TilingTypeNC6_15b(),
                           new TilingTypeNC6_16a(),
                           new TilingTypeNC6_16b(),
                           new TilingTypeNC6_17(),
                           new TilingTypeNC6_18a(),
                           new TilingTypeNC6_18b(),
                           new TilingTypeNC6_19a(),
                           new TilingTypeNC6_19b(),
                           new TilingTypeNC6_20(),
                           new TilingTypeNC6_21(),
                           new TilingTypeNC6_22a(),
                           new TilingTypeNC6_23(),
                           new TilingTypeNC6_24(),
                           new TilingTypeNC6_25(),
                           new TilingTypeNC6_26a(),
                           new TilingTypeNC6_26b(),
                           new TilingTypeNC6_27a(),
                           new TilingTypeNC6_27b(),
                           new TilingTypeNC6_28(),
                           new TilingTypeNC6_29(),
                           new TilingTypeNC6_30(),
                           new TilingTypeNC6_31(),
                           new TilingTypeNC6_32(),
                           new TilingTypeNC6_33a(),
                           new TilingTypeNC6_33b(),
                           new TilingTypeNC6_33c(),
                           new TilingTypeNC6_34(),
                           new TilingTypeNC6_35a(),
                           new TilingTypeNC6_35b(),
                           new TilingTypeNC6_36(),
                           new TilingTypeNC6_37(),
                           new TilingTypeNC6_38a(),
                           new TilingTypeNC6_38b(),
                           new TilingTypeNC6_39(),
                           new TilingTypeNC6_40a(),
                           new TilingTypeNC6_40b(),
                           new TilingTypeNC6_41(),
                           new TilingTypeNC6_42(),
                           new TilingTypeNC6_43(),
                           new TilingTypeNC6_44(),
                           new TilingTypeNC6_45(),
                           new TilingTypeNC6_46(),
                           new TilingTypeNC6_47(),
                           new TilingTypeNC6_48(),
                           new TilingTypeNC6_49(),
                           new TilingTypeNC6_50a(),
                           new TilingTypeNC6_50b(),
                           new TilingTypeNC6_50c(),
                           new TilingTypeNC6_51a(),
                           new TilingTypeNC6_51b(),
                           new TilingTypeNC6_51c(),
                           new TilingTypeNC6_52(),
                           new TilingTypeNC6_53(),
                           new TilingTypeNC6_54a(),
                           new TilingTypeNC6_54b(),
                           new TilingTypeNC6_54c(),
                           new TilingTypeNC6_54d(),
                           new TilingTypeNC6_54e(),
                           new TilingTypeNC6_54f(),
                           new TilingTypeNC6_54g(),
                           new TilingTypeNC6_54h(),
                           new TilingTypeNC6_55(),
                           new TilingTypeNC6_56(),
                           new TilingTypeNC6_57(),
                           new TilingTypeNC6_58(),
                           new TilingTypeNC6_59(),
                           new TilingTypeNC6_60(),
                           new TilingTypeNC6_61(),
                           new TilingTypeNC6_62(),
                           new TilingTypeNC6_63a(),
                           new TilingTypeNC6_63b(),
                           new TilingTypeNC6_64(),
                           new TilingTypeNC6_65a(),
                           new TilingTypeNC6_65b(),
                           new TilingTypeNC6_66(),
                           new TilingTypeNC6_67(),
                           new TilingTypeNC6_68(),
                           new TilingTypeNC6_69(),
                           new TilingTypeNC6_70(),
                           new TilingTypeNC6_71(),
                           new TilingTypeNC6_72(),
                     },
                     new Object[]{
                           "3-Isohedral",
                           new TilingTypeNC6_19c(),
                           new TilingTypeNC6_22b(),
                           new TilingTypeNC6_99(),
                           new TilingTypeNC6_100(),
                           new TilingTypeNC6_101(),
                           new TilingTypeNC6_102a(),
                           new TilingTypeNC6_102b(),
                     }
               },
         }
   };

   JTree tree;
   private ActionListener listener;
   private JButton prevButton = new JButton("Previous");
   private JButton nextButton = new JButton("Next");
   private JCheckBox[] filterBoxes;
   public PanelChooseTiling(ActionListener listener0){
      setLayout(new BorderLayout());

      JPanel topPanel = new JPanel(new BorderLayout());

      // Create the tree menu
      setPreferredSize(new Dimension(200,500));
      tree = new JTree();
      tree.setRootVisible(true);

      // only allow 1 selection
      DefaultTreeSelectionModel m = new DefaultTreeSelectionModel();
      m.setSelectionMode(DefaultTreeSelectionModel.SINGLE_TREE_SELECTION);
      tree.setSelectionModel(m);
      // no icons
      DefaultTreeCellRenderer cr = new DefaultTreeCellRenderer();
      cr.setOpenIcon(null);
      cr.setClosedIcon(null);
      cr.setLeafIcon(null);
      tree.setCellRenderer(cr);

      topPanel.add(new JScrollPane(tree));
      tree.setSelectionRow(0);

      Box bot = Box.createHorizontalBox();
      bot.add(prevButton);
      bot.add(nextButton);
      topPanel.add( bot, BorderLayout.NORTH);
      prevButton.addActionListener(this);
      nextButton.addActionListener(this);

      Box bottomPanel = Box.createVerticalBox();
      SymmetryType[] types = SymmetryType.values();
      filterBoxes = new JCheckBox[types.length+1];
      int i = 0;

      JCheckBox checkbox = new JCheckBox("Select All", true);
      bottomPanel.add(checkbox);
      checkbox.addActionListener(this);
      filterBoxes[i++] = checkbox;

      bottomPanel.add(Box.createVerticalStrut(10));
      for( SymmetryType t : types ){
         checkbox = new JCheckBox(t.toString(), true);
         bottomPanel.add(checkbox);
         checkbox.addActionListener(this);
         filterBoxes[i++] = checkbox;
      }

      JSplitPane split = new JSplitPane( JSplitPane.VERTICAL_SPLIT, true, topPanel, new JScrollPane(bottomPanel));
      add(split);
      split.setResizeWeight(.6);

      listener = listener0;
      createTree();
      tree.addTreeSelectionListener(this);
   }

   void setFocus(){
      tree.requestFocusInWindow(); 
   }

   private void createTree(){
      boolean[] filter = new boolean[filterBoxes.length-1];
      for(int i=0; i<filter.length; i++)
         filter[i] = filterBoxes[i+1].isSelected();
      TreeNode root = createNode(menuData, filter);
      ((DefaultTreeModel)tree.getModel()).setRoot(root);
   }
   private MutableTreeNode createNode(Object nodeData, boolean[] filter){
      if( nodeData instanceof TilingType ){
         return filter[((TilingType)nodeData).symmetryType().ordinal()] ?
            new DefaultMutableTreeNode(nodeData) : null;
      }

      Object[] nodeList = (Object[])nodeData;
      DefaultMutableTreeNode node = new DefaultMutableTreeNode();
      for(int i=1; i<nodeList.length; i++){
         MutableTreeNode subnode = createNode(nodeList[i],filter);
         if( subnode!=null )node.add(subnode);
      }

      // count number of unique leave types, i.e. number of different tiling types
      Set<Class<? extends TilingType>> set = new HashSet<Class<? extends TilingType>>();
      @SuppressWarnings("unchecked")
      Enumeration<DefaultMutableTreeNode> en = node.depthFirstEnumeration();
      while( en.hasMoreElements() ){
         DefaultMutableTreeNode leaf  = en.nextElement();
         if( leaf.isLeaf() && leaf.getUserObject() instanceof TilingType) set.add(((TilingType)leaf.getUserObject()).getClass());
      }

      if( set.isEmpty() ) return null;
      String name = (String)nodeList[0] + " ("+set.size()+")";
      node.setUserObject(name);
      return node;
   }

   public ITilingType getSelectedTiling(){
      TreePath path = tree.getSelectionPath();
      if (path==null) return null;
      DefaultMutableTreeNode sel = (DefaultMutableTreeNode)path.getLastPathComponent();
      if( !sel.isLeaf()  || !( sel.getUserObject() instanceof ITilingType) )return null;
      ITilingType tt = (ITilingType)sel.getUserObject();
      tt.initialise();
      return tt;
   }

   public void valueChanged(TreeSelectionEvent arg0) {
      listener.actionPerformed(new ActionEvent(this,0,""));
   }

   public void actionPerformed(ActionEvent ae) {
      if( ae.getSource() == prevButton ){
         moveSelection(true);
      }else if( ae.getSource() == nextButton ){
         moveSelection(false);
      }else{
         if( ae.getSource() == filterBoxes[0] ){
            for( int i=1; i<filterBoxes.length; i++ ){
               filterBoxes[i].removeActionListener(this);
               filterBoxes[i].setSelected(filterBoxes[0].isSelected());
               filterBoxes[i].addActionListener(this);
            }
         }
         createTree();
      }
   }
   private void moveSelection(boolean upwards){
      TreePath path = tree.getSelectionPath();
      if (path==null) path = tree.getPathForRow(0);
      DefaultMutableTreeNode oldsel = (DefaultMutableTreeNode)path.getLastPathComponent();
      DefaultMutableTreeNode newsel;
      if( upwards ){
         newsel = oldsel.getPreviousLeaf();
         if( newsel==null ) newsel = (DefaultMutableTreeNode)tree.getPathForRow(0).getLastPathComponent();
      }else{
         newsel = oldsel.isLeaf() ? oldsel.getNextLeaf() : oldsel.getFirstLeaf();
      }
      if( newsel!=null ){
         TreePath path2 = new TreePath(newsel.getPath());
         while( path.getPathCount()>1 && ! newsel.isNodeChild( (DefaultMutableTreeNode)(path.getLastPathComponent()))) {
            path = path.getParentPath();
            tree.collapsePath(path);
         }
         tree.setSelectionPath(path2);
         tree.scrollPathToVisible(path2);
      }
   }
}
